



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Swift 用Delegate和Block实现回调的Demo</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Swift 用Delegate和Block实现回调的Demo</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 06:47:22 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>一、有关回调</p>
<p>我们知道，执行函数的时候，一般都有return作为返回参数了，那有return了为什么还要回调呢？</p>
<p>回调是为了实现异步的返回，在某些特殊的情况下，比如你执行的函数是一个长时间运行的函数，并不能直接返回给你结果，为了不影响源程序其他步骤的执行，你得继续执行下去，等那边产生结果了再&ldquo;主动告诉你&rdquo;结果是什么。</p>
<p><strong>其原理不外乎：A调用B中函数，传递参数和自身指针，B执行完成再通过传递过来的指针重新调用A中函数。</strong></p>
<p>在iOS开发中，实现回调的方式有：Delegate和Block。前者用变量指针实现，后者用函数指针实现。</p>
<p>假如我现在有一个processData的类用来处理数据，处理完之后回调给主要的Class。</p>
<p>二、Swift中实现回调</p>
<p>1.代理模式：利用protocol+引用变量</p>
<p><strong>processData.swift</strong></p>
<div>
<pre class="prettyprint linenums">//<br />
//  ProcessData.swift

import UIKit<br />
//定义协议<br />
protocol callBackDelegate {<br />
    func callbackDelegatefuc(backMsg:String)<br />
}

class ProcessData: NSObject{<br />
    //定义一个符合改协议的代理对象<br />
    var delegate:callBackDelegate?<br />
    func processMethod(cmdStr:String?){<br />
        if((delegate) != nil){<br />
            delegate?.callbackDelegatefuc("backMsg---by delegate")<br />
        }<br />
    }<br />
}</pre>
</div>
<p><strong>ViewController.swift</strong></p>
<div>
<pre class="prettyprint linenums">//<br />
//  ViewController.swift

import UIKit

//继承该协议<br />
class ViewController: UIViewController,callBackDelegate{

    override func viewDidLoad() {<br />
        super.viewDidLoad()<br />
        let process=ProcessData()

        //把process的delegate变量指针指向自己，那样process就能调用自己类里的函数了<br />
        process.delegate=self

        //执行函数<br />
        process.processMethod("startProcess")<br />
    }

    override func didReceiveMemoryWarning() {<br />
        super.didReceiveMemoryWarning()<br />
    }

    //delegate回调<br />
    func callbackDelegatefuc(backMsg:String){<br />
        print(backMsg)<br />
    }<br />
}
</pre>
</div>
<p>2.利用闭包实现：</p>
<p>闭包在Objective-C中被称为Block，在Swift中被成为Closure(在Java中称为Lambda)</p>
<p>2.1利用闭包变量实现回调</p>
<p><strong>processData.swift</strong></p>
<div>
<pre class="prettyprint linenums">//<br />
//  ProcessData.swift

import UIKit

class ProcessData: NSObject{<br />
    //定义block<br />
    typealias fucBlock = (backMsg :String) -&gt;()<br />
    //创建block变量<br />
    var blockproerty:fucBlock!

    func processMethod(cmdStr:String?){<br />
        if let _ = blockproerty{<br />
            blockproerty(backMsg: "backMsg---by block property")<br />
        }<br />
    }<br />
}</pre>
</div>
<p><strong>ViewController.swift</strong></p>
<div>
<pre class="prettyprint linenums">//<br />
//  ViewController.swift

import UIKit

class ViewController: UIViewController{

    override func viewDidLoad() {<br />
        super.viewDidLoad()<br />
        let process=ProcessData()

        //block回调<br />
        process.blockproerty={ (backMsg) in<br />
            print(backMsg)<br />
        }

        //执行函数<br />
        process.processMethod("processStart")<br />
    }

    override func didReceiveMemoryWarning() {<br />
        super.didReceiveMemoryWarning()<br />
    }<br />
}
</pre>
</div>
<p>2.2 把闭包写入函数作参数实现快速回调，可见这是一种代码最为简洁的方案</p>
<p><strong>processData.swift</strong></p>
<div>
<pre class="prettyprint linenums">//<br />
//  ProcessData.swift

import UIKit

class ProcessData: NSObject{<br />
    //定义block<br />
    typealias fucBlock = (backMsg :String) -&gt;()

    func processWithBlock(cmdStr:String?,blockProperty:fucBlock){<br />
        blockProperty(backMsg :"backMsg---by block inside func")<br />
    }<br />
}</pre>
</div>
<p><strong>ViewController.swift</strong></p>
<div>
<pre class="prettyprint linenums">//<br />
//  ViewController.swift

import UIKit

class ViewController: UIViewController{

    override func viewDidLoad() {<br />
        super.viewDidLoad()<br />
        let process=ProcessData()

        //函数内回调<br />
        process.processWithBlock("bbb") { (backMsg) in<br />
            print(backMsg)<br />
        }<br />
    }

    override func didReceiveMemoryWarning() {<br />
        super.didReceiveMemoryWarning()<br />
    }<br />
}
</pre>
</div>
<p>PS：如果Block带返回值的情况下，Block是这样定义和调用的</p>
<div>
<pre class="prettyprint linenums">//定义block<br />
    typealias fucBlock = (backMsg :String) -&gt;(String)
</pre>
</div>
<div>
<pre class="prettyprint linenums">//函数内回调<br />
        process.processWithBlock("bbb") { (backMsg) -&gt;(String) in<br />
            print(backMsg)<br />
            return "get msg"<br />
        }&nbsp;</pre>
</div>
<p>2.3.刚使用的typealias把block给定义给一个变量了，现在直接代替进去就可以了，并且我给函数再加个String类型返回值。。</p>
<p><strong>processData.swift</strong></p>
<div>
<pre class="prettyprint linenums">func processWithBlock(cmdStr:String?,blockProperty:(backMsg :String) -&gt;())-&gt;(String){<br />
        blockProperty(backMsg :"backMsg---by block inside func")<br />
        return ""<br />
    }
</pre>
</div>
<p>swift:<a href="https://github.com/rayshen/SwiftClosure" rel="external nofollow noreferrer">https://github.com/rayshen/SwiftClosure</a></p>
<p>oc:<a href="https://github.com/rayshen/callbackDemo" rel="external nofollow noreferrer">https://github.com/rayshen/callbackDemo</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qn5y7kq.html">tsql语句分析工具 转</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1ee5v9.html">ejabberd中的http反向推送</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdpmpd8.html">spring quartz 多次调用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m1r5kq.html">ScheduleThreadPoolExecutor源码分析（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdx7ze8.html">&lbrack;转&rsqb;Android重力感应开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j05z2wq.html">vuex 模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmzdkx9.html">&lbrack; javascript &rsqb; 司徒正美的fadeOut-fadeIn效果&excl;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpodrjq.html">2017&period;3&period;3自测j纠错题&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/950jdgz8.html">C&num;-MVC开发微信应用&lpar;2&rpar;--OAuth2&period;0网页授权</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkjvoj8.html">jQuery 事件绑定 和 JavaScript 原生事件绑定</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpyey0q.html">Python中使用MongoEngine3</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljzmx19.html">js单元测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvnrlg8.html">朱晔和你聊Spring系列S1E9：聊聊Spring的那些注解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2kd6x9.html">C&sol;C&plus;&plus;预处理器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv6zrk8.html">Android 使用开源库StickyGridHeaders来实现带sections和headers的GridView显示本地图片效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2nz4z8.html">针对Jigsaw勒索软件的解锁工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/qveelpx9.html">树莓派命令行配置连接wifi</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jme00w9.html">SQLServer2008&sol;2005 生成数据字典语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7edpnk9.html">linux 查找删除找定文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwle00z9.html">java各种框架的比较，分析</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/xq46rn08.html">Cocos2d-x 3&period;4在AndroidStudio上编译配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv7671q.html">unix环境高级编程基础知识之第一篇</a>
			</li>
						<li><a href="https://www.batexi.com/a/r936e1g9.html">翻译qmake文档&lpar;二&rpar; Getting Started</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o27nx9.html">Expression Blend4经验分享：制作一个简单的图片按钮样式</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gxngeq.html">Reflection和Expression Tree解析泛型集合快速定制特殊格式的Json</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv7ggjq.html">unittest使用过程中sys&period;exit&lpar;not self&period;result&period;wasSuccessful&lpar;&rpar;&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwxd7z9.html">Windows10一周年庆典壁纸</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn0jdg9.html">取消Git代理设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/390lmpm9.html">20 seq   某个数到另外一个数之间的所有整数</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvn2do9.html">网页之间信息传递方式（Cookie&comma;Session）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
